// =================================================================================
//
//	CPictControl.h				1996 Microsoft Corporation All rights reserved.
//
// =================================================================================

#ifndef _H_CPictControl
#define _H_CPictControl
#pragma once

#include "CBaseControl.h"

class CPictControlBSC;

typedef struct
{
	CPictControlBSC*	BSC;
	Rect				PicRect;
	PicHandle			Pic;
}
pictinfo;

class CPictControl:
		public CBaseControl
{
	friend CPictControlBSC;	//	needs access to our private SetData method

public:
	// *** CPictControl methods ***
	CPictControl();
	~CPictControl();

	// *** IControl methods ***
	STDMETHOD (Draw) (THIS_ DrawContext* inContext);
	STDMETHOD (SetFocus) (THIS_ FocusCommand inCommand, FocusSet inFocus);
	STDMETHOD (DoMouse)(THIS_ MouseEventType inMouseET, PlatformEvent* inEvent);
	STDMETHOD (DoIdle)(THIS_ Uint32 IdleRefCon);

	//  *** IPersistPropertyBag methods ***
	STDMETHOD (Load)(IPropertyBag* PropBag, IErrorLog* ErrorLog);

protected:
	//	*** CBaseControl method overrides ***
	virtual Boolean8	StartIdling(void);
	virtual Boolean8	StopIdling(void);

	//  *** CPictControl methods ***
	void 		DrawPict(GrafPtr pGrafDraw, Rect* lprect, PicHandle Pic, Rect* PictRect);
	Boolean8	HandlePopUpMenuClick(PlatformPoint inEventLocation);
	void		SetData(Handle Data, Uint32 PictIndex);
	void		AdvancePict(void);

	//  *** CPictControl members ***
	Point				mSize;
	Int32				mCycleWaitTime;
	Handle				mDataURLBuffer;
	pictinfo**			mPicts;
	Int16				mCurrentPict;
	Int16				mPictCount;
	Boolean8			mAutoCycle;
	FocusSet			mOwnedFoci;
};

#endif
